//+------------------------------------------------------------------+
//|                                             Epsilon Megastar.mq4 |
//|                                  Copyright  2009, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
/*
I retain the copyright to this code, but that is a de-facto state of law. So far as I am concerned,
it is open source. Coders should feel free to adapt it, pinch it, use it in their own robots. Please 
just respect the spirit of FF and refrain from using it in a commercial product.
*/

#property copyright "Copyright  2009, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n" 
#define  up "Up"
//#define  upbutuntradable  "Up, but untradable"
#define  down "Down"
//#define  downbutuntradable "Down, but untradable"
#define  undecided "No trend yet"
#define  unchanged "No change"
#define  ranging "Ranging"
#define  GV "Fib_"
#define  ValidFib "Fib is valid and can be traded"
#define  InValidFib "Fib is not yet valid and cannot be traded"
#define  high "Swing High"
#define  low "Swing Low"

/*
void DisplayUserFeedback()
void GetPositionInformation()
void SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
bool CloseAllTrades()
bool CheckForExitSignal(int type)
bool DoesTradeExist(double PriceHigh, double PriceLow)
void ScaleOut()

----Trading strategies----
void TradeOriginalStrategy()
void TradeEarlierEntryStrategy()


----Fib lines, trend etc----
void GetSwing(int Tf)
void GetFibLevels(string Name)
void DrawFib(string Name, color col)


from rfking2:
I find it really profitable to add more lots at the tip of a retrace, usually around 50% or 61% 
(which is normally my entry point in a hard moving market to catch a trend). 
Also because it makes the market a little more predictable, you can time large hedges well to break even open 
losses fast. Might be some good addition ideas for you

In order to incorperate a proper hedging strategy. The EA would first need to recognize the trade is far 
enough in the red. Identify a good swing in the other direction. Draw a fib from that swing, then set a stop 
for early entry on the retrace. And finally scale in more trades to break even quikly. When done correctly is has 
a high probability of working. But bear in mind the risk because the rsi will be showing a trend in the other direction.

from bluemele
I learned to trade from a very successful mentor (nobody you know and not currencies) who trades daily and makes 
quite a bit of $ annually. I am on the path of emulating him and some of it is rubbing off... especially the psychological values.

Anyways, this is how he trades (a stop for him = 30K to 60K and they are very small and I believe he trades about 
1.2M per trade roughly):

1. Full entry
2. TP @ 50% to 65% of his order at the most likely pivot (fib retr 50%, 61%, 76%, double top etc..) 
(fib extensions (100%, 138%, 161%, 200%) -- Whatever has multiple matches and creates the best story. Kind of hard to 
do in a bot... He will scale in though and add once the story corrects itself.

3. Exits the rest on the retracement or a significant change in other indicators showing this is no longer a 
good game to be in.

I believe the biggest challenge here with this strategy and where you will lose the most money is on the 
RSI (flip) from long's to short's and the transition period of such.

Usually when something trends it trends hard, then range's and then trends... On larger timeframes 
these 'ranges' will be at the 23, 38, 50, 76 etc.. But, on the smaller time frames (i.e. 4H and below) the 
ranges will be 'trends' obviously and the key is not getting washed up when it flips directions on the longer term.


Version history

V1:   Stripped out extra Rsi filters
      Made Rsi tf a user input
      Removed the 'Rsi must be going in the right direction' filter. Commented rather than removed in case of change of mind
      Added code to make the trends start at 55/45
      Added optional code to make the 'hard stop' follow the hi-lo as the fib moves to follow the swing

V2:   The robot takes trades on its way through the post-corrective trend-return phase i.e.
         Sells at below the 50, 38.2, 25, 0
         Buys above the 50, 61.8, 75, 100
      Added the manual trend setting code
      Added the ZigZag user inputs

This: Combined the trade-sending methods of V1 & 2 so the robot is a 2 mode bot
      Added DxTrade's option to stop redrawing the fib after a trade opend


*/
extern string     tm="----Trading mode----";
extern bool       TradeOriginalStrategy=false;
extern bool       TradeEarlyEntries=false;
extern bool       TradeRfking2NightMode=true;
extern string     gs="----General inputs----";
extern double     Lot=0.04;
extern int        MagicNumber=75343;
extern string     TradeComment="xxx";
extern bool       StopTrading=false;
extern int        GlobalMaximumTradesAllowed=16;
extern bool       CriminalIsECN=false;
extern string     fib="----Fibs----";
extern string     tf="Trading fib";
extern bool       RobotDrawsFib=true;
extern bool       RobotAdjustsFib=true;
extern bool       RobotAdjustsFibAfterTradeOpens=true;
extern bool       UseDynamicSwingCalculation=true;
extern double     MinimumFibSize=600;
extern color      FibColour=Yellow;
extern string     mtfi="Medium time frame fib";
extern int        MediumTimeFrame=60;
extern bool       RobotDrawsMtfFib=true;
extern bool       RobotAdjustsMtfFib=true;
extern bool       RobotAdjustsMtfFibAfterTrade=true;
extern bool       UseDynamicSwingMtfCalculation=true;
extern color      MtfFibColour=White;
extern string     htfi="Higher time frame fib. D1=1440";
extern int        HigherTimeFrame=240;
extern bool       RobotDrawsHtfFib=true;
extern bool       RobotAdjustsHtfFib=true;
extern bool       RobotAdjustsHtfFibAfterTrade=true;
extern bool       UseDynamicSwingHtfCalculation=true;
extern color      HtfFibColour=Turquoise;
extern string     sl="----Stop loss----";
extern int        StopLoss=500;
extern bool       UseAdaptableStopLoss=true;
extern string     osi="----Trade scale in----";
extern bool       UseScaleIn=true;
extern int        ScaleIncrement=4;
extern int        MinPipsToNextTrade=100;
extern string     rsii="----Rsi inputs----";
extern string     rsit="D1 = 1440; W1 = 10080; MN1 = 40320";
extern int        RsiTimeFrame=60;
extern int        RsiPeriod=21;
extern string     zz="----ZigZag inputs----";
extern int        ExtDepth=12;
extern int        ExtDeviation=5;
extern int        ExtBackstep=3;
extern string     tt="----Trading hours----";
extern string     Trade_Hours= "Set Morning & Evening Hours 24hr";
extern string     Trade_Hours_M= "Morning Hours 0-12";
extern  int       start_hourm = 0;
extern  int       end_hourm = 12;
extern string     Trade_Hours_E= "Evening Hours 12-24";
extern  int       start_houre = 12;
extern  int       end_houre = 24;
extern bool       TradeSundayCandle=false;
extern string     mt="----Manual trading----";
extern bool       ShowAlertNotSendTrade=false;
extern bool       ShowAlertNotCloseTrade=false;
extern string     mov="----Manual trend setting----";
extern bool       OverrideRobot=false;
extern bool       MarketTrendIsLong=false;
extern bool       MarketTrendIsShort=false;
extern bool       MarketIsRanging=false;
extern string     soi="----Scale-out----";
extern bool       UseScaleOut=true;
extern double     BuyScaleOutLevel1=61.8;
extern double     BuyScaleOutLot1=0.02;
extern double     BuyScaleOutLevel2=75;
extern double     BuyScaleOutLot2=0.01;
extern double     BuyScaleOutLevel3=100;
extern double     BuyScaleOutLot3=0.01;
extern double     SellScaleOutLevel1=38.2;
extern double     SellScaleOutLot1=0.02;
extern double     SellScaleOutLevel2=25;
extern double     SellScaleOutLot2=0.01;
extern double     SellScaleOutLevel3=0;
extern double     SellScaleOutLot3=0.01;
extern string     oae="----Odds and ends----";
extern int        DisplayGapSize=30;

//Fib
//General variables for calculating fib levels
double            cFibSize;
double            cFibUpperConfirm;//75
double            cFibHigh;//100
double            cFibUpperRetrace;//61.8
double            cFibPivot;//50
double            cFibLowerRetrace;//38.2
double            cFibLowerConfirm;//25
double            cFibLow;//0
//Trading fib
double            FibSize;
double            FibUpperConfirm;//75
double            FibHigh;//100
double            FibUpperRetrace;//61.8
double            FibPivot;//50
double            FibLowerRetrace;//38.2
double            FibLowerConfirm;//25
double            FibLow;//0
bool              FibIsValid;
double            FibLevel[5];
//Medium time frame
double            MtfFibSize;
double            MtfFibUpperConfirm;//75
double            MtfFibHigh;//100
double            MtfFibUpperRetrace;//61.8
double            MtfFibPivot;//50
double            MtfFibLowerRetrace;//38.2
double            MtfFibLowerConfirm;//25
double            MtfFibLow;//0
//Higher time frame
double            HtfFibSize;
double            HtfFibUpperConfirm;//75
double            HtfFibHigh;//100
double            HtfFibUpperRetrace;//61.8
double            HtfFibPivot;//50
double            HtfFibLowerRetrace;//38.2
double            HtfFibLowerConfirm;//25
double            HtfFibLow;//0

//Names
string            FiboName = "Fibo";
string            MtfFiboName = "MtfFibo";
string            HtfFiboName = "HtfFibo";


//Swing
double            SwingLow;
double            SwingHigh;
double            WaveHeight;
double            MinWave=400;
datetime          SwingStartTime, SwingEndTime;
string            LatestSwing;

//Rsi
double            RsiVal;
//double            PreviousRsiVal;
//string            RsiDirection;

//Trading
double            OpenLotSize;//Total of lot sizes open - scale in
int               OpenTradesTotal;//Holds total of all this instance of robot trades
double            TotalProfit;//Holds the upl of this chart's open trades
int               GlobalTotalTradesOpen;//Keeps an eye on the number of trades open for all pairs
double            StopLossPrice;//Stop loss of the first order in scale in
bool              CloseAllBuys, CloseAllSells;
double            HighestBuyTrade, LowestSellTrade;//For scaling in. Hi-low trade prices to avoid scaling in at the same price
bool              TradeHour;

//Misc
string            ScreenMessage, Gap, Trend, GvName;
int               OldBars;
bool              RobotDisabled;
string            DisabledMessage;
int               StopLossPips=100;//Pips from impulse hi-lo for the stop

void DisplayUserFeedback()
{

   ScreenMessage = "";
   if (RobotAdjustsFib) 
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "RobotAdjustsFib = true: ");
      if (RobotAdjustsFibAfterTradeOpens) ScreenMessage = StringConcatenate(ScreenMessage, "continuing to adjust fib after trade opens");
      else  ScreenMessage = StringConcatenate(ScreenMessage, "not adjusting fib after trade opens");
   }
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "RobotAdjustsFib = false");
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, NL);
   if (UseDynamicSwingCalculation) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using dynamic minimum swing calculation");
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not using dynamic minimum swing calculation");
   ScreenMessage = StringConcatenate(ScreenMessage, "Minimum fib zize: ", DoubleToStr(MinimumFibSize * Point, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Current fib zize:   ", DoubleToStr(FibSize, Digits), NL);
   if (FibIsValid) ScreenMessage = StringConcatenate(ScreenMessage, Gap, ValidFib, NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, InValidFib, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "High (100):.........................", DoubleToStr(FibHigh, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Upper confirm (75):..............", DoubleToStr(FibUpperConfirm, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Channel retrace high (61.8):..", DoubleToStr(FibUpperRetrace, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Pivot (50):..........................", DoubleToStr(FibPivot, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Channel retrace low (38.2):...", DoubleToStr(FibLowerConfirm, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lower confirm (25):..............", DoubleToStr(FibLowerRetrace, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Low (0):.............................", DoubleToStr(FibLow, Digits), NL);
   if(OverrideRobot) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Overriding the robot's trend spotting", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trend is ", Trend, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Most recent swing: ", LatestSwing, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Rsi tf = ", RsiTimeFrame, ": Period = ", RsiPeriod , NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Rsi is ", RsiVal, NL);
   //ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Rsi is ", RsiVal, " {", RsiDirection, ")", NL);
   //ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Previous candle Rsi was ", PreviousRsiVal, NL);
   //RsiDirection = unchanged; H4RsiDirection = unchanged; H1RsiDirection = unchanged;
         
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   if (TradeRfking2NightMode) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading Rfking2 NightMode", NL);
   if (TradeOriginalStrategy) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading original strategy", NL);
   if (TradeEarlyEntries) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading early entries strategy", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lots: ", Lot, NL);
   if (UseAdaptableStopLoss) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using adaptable stop loss: ", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Stop loss: ", StopLoss, " pips", NL);
   //if (UseScaleIn) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using trade scale-in. Increments are ", 
   //                Lot / ScaleIncrement, " lots. Minimum pips to next trade = ", MinPipsToNextTrade, NL);
   if (UseScaleIn) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using trade scale-in. Increments are ", 
                   Lot / ScaleIncrement, " lots.", NL);
   if (UseScaleOut) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using trade scale-out", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not using trade scale-out", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Magic number: ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment: ", TradeComment, NL);
   if (!StopTrading) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading allowed", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading is not allowed - StopTrading = false", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Leverage: ", AccountLeverage(), NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Spread: ", MarketInfo(Symbol(), MODE_SPREAD), NL);
   if (!TradeSundayCandle) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not trading the Sunday candle", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading the Sunday candle", NL);
   if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal()) == 0) 
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not trading the Sunday candle, but still monitoring any open trades",NL);
   }//if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal()) == 0) 
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading hours: ");
   if (start_hourm == 0 && end_hourm == 12 && start_houre == 12 && end_houre == 24) ScreenMessage = StringConcatenate(ScreenMessage, "24 hour trading", NL);
   else
   {
      ScreenMessage = StringConcatenate(ScreenMessage, "AM: ", DoubleToStr(start_hourm, 2), "-", DoubleToStr(end_hourm, 2),":  PM: ", DoubleToStr(start_houre, 2), "-", DoubleToStr(end_houre, 2), NL);
   }//else
   if (!TradeHour) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Outside trading hours. Continuing to monitor open trades for exit signals", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Open trades total: ", OpenTradesTotal);
   if (OpenTradesTotal > 0 && UseScaleIn)
   {
      if (HighestBuyTrade > 0) ScreenMessage = StringConcatenate(ScreenMessage, " (", DoubleToStr(HighestBuyTrade, Digits), ")");
      if (LowestSellTrade > 0) ScreenMessage = StringConcatenate(ScreenMessage, " (", DoubleToStr(LowestSellTrade, Digits), ")");
   }//if (OpenTradesTotal > 0)
   ScreenMessage = StringConcatenate(ScreenMessage, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "This chart. Open trades Lots: ", OpenLotSize);
   ScreenMessage = StringConcatenate(ScreenMessage, ":  Open trades upl: ", DoubleToStr(TotalProfit, 2), NL);   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Globally. Open trades = ", GlobalTotalTradesOpen, NL);
   if (GlobalTotalTradesOpen >= GlobalMaximumTradesAllowed) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Global trading limit reached", NL);
   if (StopTrading) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not sending new orders, but still monitoring any open trades",NL);
   if (ShowAlertNotSendTrade) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Alerting you to trade setups, but not sending the trade",NL);
   if (ShowAlertNotCloseTrade) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Alerting you to trade exits, but not closing the trade",NL);
   
   
   Comment(ScreenMessage);
   
}//void DisplayUserFeedback()

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
   
   //Check magic number.
   if (!IsDemo() )
   {
      if (MagicNumber == 75343)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 75343." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 12345)
   }//if (!IsDemo)
      
   //Insufficient length
   string mn = DoubleToStr(MagicNumber,0);
   if (StringLen(mn) < 5)
   {
      MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                 + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
      Comment("                This robot can do nothing. Please reload it");
      DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
      RobotDisabled = true;
      return;
   }//if (StringLen(mn) < 5)

   
   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }//if (DisplayGapSize >0)
   
   //Adjust settings for 4 digit crim
   if (Digits == 2 || Digits == 4)
   {
      MinimumFibSize/= 10;
      MinWave/= 10;
      StopLoss/= 10;
      MinPipsToNextTrade/= 10;
      StopLossPips/= 10;
      
   }//if (Digits == 2 || Digits == 4)

   //MinimumFibSize*= Point;
   
   //Draw fibs from smallest to largest to ensure that each larger swing has extremes that encompass the smaller ones
   SwingHigh = 0;
   SwingLow = 1000000;
   GetSwing(Period() );   
   GetFibLevels(FiboName);

   if (RobotDrawsMtfFib) 
   {
      GetSwing(MediumTimeFrame);
      GetFibLevels(MtfFiboName);
      DrawFib(MtfFiboName, MtfFibColour);
   }//if (RobotDrawsHtfFib) 

   if (RobotDrawsHtfFib) 
   {
      GetSwing(HigherTimeFrame);
      GetFibLevels(HtfFiboName);
      DrawFib(HtfFiboName, HtfFibColour);
   }//if (RobotDrawsHtfFib) 


   SwingHigh = 0;
   SwingLow = 1000000;
   GetSwing(Period() );//Needs re-reading
   GetFibLevels(FiboName);//Needs re-reading
   if (RobotDrawsFib) DrawFib(FiboName, FibColour);
      
   
   
   GvName = GV + Symbol();
   if (!GlobalVariableCheck(GvName) ) GlobalVariableSet(GvName, 0);// 0 means fib is invalid, 1 means it is valid
   
   GetPositionInformation();
   DisplayUserFeedback();
   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   ObjectDelete(FiboName);
   ObjectDelete(MtfFiboName);
   ObjectDelete(HtfFiboName);
   
   
//----
   return(0);
}
  
void GetFibLevels(string Name)
{
   //User can use horizontal lines to indicate support and resistance.
   //This function reads these lines, and sets up FibLow & FibHigh
   //for use in trading decisions.

   
   
   //Cater for users not adding the correctly named Fib
   //default settings
   //if (!ObjectGet("Fibo", OBJPROP_PRICE1) ) 
   //{
      //Alert(Symbol(), " You have not named your fib object 'Fibo' ");
      //return;
   //}//if (!ObjectGet("Fibo", OBJPROP_PRICE1) ) 
   
   //These two lines changed following a request from fxdrive. They will make the robot back-testable
   //FibHigh = ObjectGet("Fibo", OBJPROP_PRICE1);//High
   //FibLow = ObjectGet("Fibo", OBJPROP_PRICE2);//Low   
   cFibHigh = SwingHigh;//Calculated in GetSwing()
   cFibLow = SwingLow;

      
   //Set up the rest of the fib lines   
   cFibSize = FibHigh - FibLow;
   cFibUpperConfirm = NormalizeDouble(FibLow + (FibSize * 75 / 100), Digits);
   cFibUpperRetrace = NormalizeDouble(FibLow + (FibSize * 61.8 / 100), Digits);
   cFibPivot = NormalizeDouble(FibLow + (FibSize * 50 / 100), Digits);
   cFibLowerRetrace = NormalizeDouble(FibLow + (FibSize * 38.2 / 100), Digits);
   cFibLowerConfirm = NormalizeDouble(FibLow + (FibSize * 25 / 100), Digits);
   
   //Copy levels into trading fib
   if (Name == FiboName)
   {
      FibSize = cFibSize;
      FibHigh = cFibHigh;
      FibUpperConfirm = cFibUpperConfirm;
      FibUpperRetrace = cFibUpperRetrace;
      FibPivot = cFibPivot;
      FibLowerRetrace = cFibLowerRetrace;
      FibLowerConfirm = cFibLowerConfirm;
      FibLow = cFibLow;
   }//if (Name == FiboName)
   
   //Copy levels into mtf fib
   if (Name == MtfFiboName)
   {
      MtfFibSize = cFibSize;
      MtfFibHigh = cFibHigh;
      MtfFibUpperConfirm = cFibUpperConfirm;
      MtfFibUpperRetrace = cFibUpperRetrace;
      MtfFibPivot = cFibPivot;
      MtfFibLowerRetrace = cFibLowerRetrace;
      MtfFibLowerConfirm = cFibLowerConfirm;
      MtfFibLow = cFibLow;
   }//if (Name == FiboName)
   
   //Copy levels into htf fib
   if (Name == HtfFiboName)
   {
      HtfFibSize = cFibSize;
      HtfFibHigh = cFibHigh;
      HtfFibUpperConfirm = cFibUpperConfirm;
      HtfFibUpperRetrace = cFibUpperRetrace;
      HtfFibPivot = cFibPivot;
      HtfFibLowerRetrace = cFibLowerRetrace;
      HtfFibLowerConfirm = cFibLowerConfirm;
      HtfFibLow = cFibLow;
   }//if (Name == FiboName)
   
   
   
}//End void GetFibLevels(string Name)
  
void GetPositionInformation()
{
   OpenLotSize = 0;
   OpenTradesTotal = 0;
   StopLossPrice = 0;
   TotalProfit = 0;
   HighestBuyTrade = 0;
   LowestSellTrade = 100000;
   GlobalTotalTradesOpen = 0;
   
   static int AlertCount;
   if (Ask < FibUpperRetrace && Bid > FibLowerRetrace) AlertCount = 0;
   
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      //Find open trades unique to this chart
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         OpenLotSize+= OrderLots();
         if (OrderStopLoss() != 0) StopLossPrice = OrderStopLoss();
         OpenTradesTotal++;
         TotalProfit+= OrderProfit();
         //Open trade types
         if (OrderType() == OP_BUY) 
         {
            bool CloseTrade = CheckForExitSignal(OP_BUY);
            if (CloseTrade)
            {
               if (ShowAlertNotCloseTrade && AlertCount == 0)
               {
                  Alert(Symbol(), " Buy trade exit signal");
                  AlertCount++;
               }//if (ShowAlertNotCloseTrade && AlertCount == 0)
               if (!ShowAlertNotCloseTrade)
               {   
                  CloseAllBuys=true;
                  bool TradesCloseFailed = CloseAllTrades();
                  if (TradesCloseFailed) 
                  {
                     OldBars = 0;
                     return;
                  }//if (TradesCloseFailed) 
                  else {CloseAllBuys = false; return;}
               }//if (!ShowAlertNotCloseTrade)   
            
            }//if (CloseTrade)
            
         }//if (OrderType() == OP_BUY) 
         
         if (OrderType() == OP_SELL)
         {
            CloseTrade = CheckForExitSignal(OP_SELL);
            if (CloseTrade)
            {
               if (ShowAlertNotCloseTrade && AlertCount == 0)
               {
                  Alert(Symbol(), " Sell trade exit signal");
                  AlertCount++;
               }//if (ShowAlertNotCloseTrade && AlertCount == 0)
               if (!ShowAlertNotCloseTrade)
               {   
                  CloseAllSells=true;
                  TradesCloseFailed = CloseAllTrades();
                  if (TradesCloseFailed) 
                  {
                     OldBars = 0;
                     return;
                  }//if (TradesCloseFailed) 
                  else {CloseAllSells = false; return;}
               }//if (!ShowAlertNotCloseTrade)   
            
            }//if (CloseTrade)
            
         }//if (OrderType() == OP_SELL)
         
         //Other management functions
         //Highest/lowest order price for scaling-in
         if (OrderType() == OP_BUY)
         {
            double SL_New=NormalizeDouble(FibLow - (StopLossPips * Point), Digits);
            if(OrderOpenPrice() > HighestBuyTrade && OrderCloseTime() == 0) HighestBuyTrade = OrderOpenPrice();
            if ((FibLow - OrderStopLoss() > StopLossPips * Point) && ( MathAbs(OrderStopLoss()-SL_New)>0.0001 ) )
            {
               bool result=OrderModify(OrderTicket(), OrderOpenPrice(), SL_New, OrderTakeProfit(), 0, CLR_NONE);
               if (!result)
                  {
                     int err=GetLastError();
                     Print(Symbol(), " OrderModify#3 Error: Type=", OrderType()," ticket=",OrderTicket()," Open=",OrderOpenPrice()," Current stop=",DoubleToStr(OrderStopLoss(),Digits)," SL_New=",DoubleToStr(SL_New,Digits)," take=",OrderTakeProfit()," Error(",err,"): ",ErrorDescription(err));              
                  }//if (!result)
            }//if (FibLow - OrderStopLoss() > StopLossPips * Point)
            
            
         }//if (OrderType() == OP_BUY
        
         if (OrderType() == OP_SELL)
         {
            SL_New=NormalizeDouble(FibHigh + (StopLossPips * Point), Digits);
            if (OrderOpenPrice() < LowestSellTrade && OrderCloseTime() == 0) LowestSellTrade = OrderOpenPrice();
            if ( (OrderStopLoss() - FibHigh > StopLossPips * Point) &&  ( MathAbs(OrderStopLoss()-SL_New)>0.0001 ) )
            {
               result=OrderModify(OrderTicket(), OrderOpenPrice(),SL_New , OrderTakeProfit(), 0, CLR_NONE);
               if (!result)
                  {
                     err=GetLastError();
                     Print(Symbol(), " OrderModify#4 Error: Type=", OrderType()," ticket=",OrderTicket()," Open=",OrderOpenPrice()," Current stop=",DoubleToStr(OrderStopLoss(),Digits) ," SL_New=",DoubleToStr(SL_New,Digits)," take=",OrderTakeProfit()," Error(",err,"): ",ErrorDescription(err));              
                  }//if (!result)
              
            }//if (FibLow - OrderStopLoss() > StopLossPips * Point)
            
         }//if (OrderType() == OP_SELL)
      
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )           
   
      //Find total of all open trades for use in deciding whether more are allowed
      if (OrderMagicNumber() == MagicNumber && (OrderType() == OP_BUY || OrderType() == OP_SELL) ) GlobalTotalTradesOpen++;
   
   }//for (int cc = OrdersTotal(); cc >= 0 ; cc--)
               


}//End void GetPositionInformation()

void SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   // Attempts to place a trade according to type, i.e.
   
   
   if (!IsTradeAllowed() ) return;
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY) col = Green;
   
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, 0, col);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, 0, col);
	   if (stop != 0)
	   {
		   if (ticket > 0)
		   bool result = OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), 0, CLR_NONE);
		   if (!result)
		   {
		       int err=GetLastError();
             Alert(Symbol(), " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
		   }//if (!result)			  
	   }//if (Sl != 0)
      
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_SELL) stype = "OP_SELL";
      err=GetLastError();
      Alert(Symbol(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      Print("Order send failed with error(",err,"): ",ErrorDescription(err));
      OldBars=0;//Force a retry at the next tick
   }//if (ticket < 0)  
   
}//End void SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)


void GetSwing(int Tf)
{
    //Detects a swing high or low. Ensures it has an acceptable wave height
    int k = 0;
    double z1 = 0;
    double z2 = 0;
    double z3 = 0;
    datetime t1,t2,t3;

    double mfib = MinimumFibSize;
    
    if (UseDynamicSwingCalculation)
    {
         mfib = iATR(NULL, Tf, 14, 0);
         if (mfib < (MinimumFibSize * Point) ) mfib = MinimumFibSize;
    }//if (UseDynamicSwingCalculation)
    
    //Save lower tf swings for comparison
    double LtfHigh = SwingHigh;
    double LtfLow = SwingLow;
    
    while(true)
    {
      while(true)
      {
        if(k == Bars) break;
        //double zz = iCustom(NULL, 0, "Zigzag", 12,5,3, 0, k);        
        if (Tf == Period() ) double zz = iCustom(NULL, Tf, "Zigzag", ExtDepth, ExtDeviation, ExtBackstep, 0, k);
        //if (Tf != Period() ) zz = iCustom(NULL, Tf, "ZigzagMe", 12,2, 0, k);
        if (Tf != Period() ) zz = iCustom(NULL, Tf, "ZigzagMe", ExtDepth,ExtBackstep, 0, k);
        if(zz!=0)
        {
          z1 = z2; z2=z3; z3=zz;
          t1 = t2; t2=t3; t3=iTime(NULL, 0, k);
        }        
        k++;
        if(z1>0) 
        {
            if (z2 < z3)
            {
               if (z2 < LtfLow)
               {
                  SwingLow = z2;
                  //LtfLow = SwingLow;
               }//if (SwingLow < LtfLow)
               
               if (z3 > LtfHigh)
               {
                  SwingHigh = z3;
                  //LtfHigh = SwingHigh;
               }//if (SwingLow < LtfLow)
                  
               
               if (SwingLow < LtfLow && SwingHigh > LtfHigh)
               {
                  SwingStartTime = t2;
                  SwingEndTime = t3;
                  LatestSwing = low;
                  break;
               }//if (SwingLow < LtfLow && SwingHigh > LtfHigh)
               
            }//if (t2 > t3)
   
            if (z2 > z3)
            {
               if (SwingLow < LtfLow)
               {
                  SwingLow = z3;
               }//if (SwingLow < LtfLow)
               
               if (SwingHigh > LtfHigh)
               {
                  SwingHigh = z2;
               }//if (SwingLow < LtfLow)
                  
               
               if (SwingLow < LtfLow && SwingHigh > LtfHigh)
               {
                  SwingStartTime = t3;
                  SwingEndTime = t2;
                  LatestSwing = high;
                  break;
               }//if (SwingLow < LtfLow && SwingHigh > LtfHigh)
               
               
               
               //SwingLow = z3;     
               //SwingHigh = z2;
               //SwingStartTime = t3;
               //SwingEndTime = t2;
               //LatestSwing = high;
               //if (SwingLow < LtfLow && SwingHigh > LtfHigh) break;
            }//if (t2 > t3)

            
        }//if(z1>0) 
      }//while(true)
     //z2 is the recent swing that occurred at candle time t2
     //z3 is the previous swing that occurred at candle time t3
     if (z2 < z3)
     {
        SwingLow = z2;     
        SwingHigh = z3;
        SwingStartTime = t2;
        SwingEndTime = t3;
        LatestSwing = low;
     }//if (t2 > t3)
   
     if (z2 > z3)
     {
        SwingLow = z3;     
        SwingHigh = z2;
        SwingStartTime = t3;
        SwingEndTime = t2;
        LatestSwing = high;
     }//if (t2 > t3)

     if(k == Bars) break;
     WaveHeight = MathAbs(z2 - z3);
     if (WaveHeight >= (mfib * Point) ) break;
   }//while(true)
   
   
}//End void GetSwing(int Tf)

bool CloseAllTrades()
{
   //Called if there are trades open and relevant ones should be closed
   
   bool ForceClosure = false;
   if (OrdersTotal() == 0) return; //Just in case
   
   
                     
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
            bool result = true;
            int CloseTicketNo = OrderTicket();
            if (OrderType() == OP_BUY && CloseAllBuys) result = OrderClose(CloseTicketNo,OrderLots(), OrderClosePrice(),5000,Blue);
            if (OrderType() == OP_SELL && CloseAllSells) result = OrderClose(CloseTicketNo,OrderLots(), OrderClosePrice(),5000,Blue);
            //Forse a retry at the next tick if the closure has failed
            if (!result) 
            {
               int err =GetLastError();
               Alert(Symbol(), " order close failed with error(",err,"): ",ErrorDescription(err));
               ForceClosure = true;
               //cc = OrdersTotal();
               Sleep(1000);
            }//if (!result) 
            
            else 
            {
               cc++;  
               Sleep(100);
            }//else   
      }//if (OrderMagicNumber()==MagicNumber)
   }//for (int cc=0; cc<OrdersTotal(); cc++)

   if (!ForceClosure)
   {
      CloseAllBuys = false;
      CloseAllSells = false;
   }//if (!ForceClosure)
   
   return(ForceClosure);

}// End bool CloseAllTrades()

bool CheckForExitSignal(int type)
{
   //Checks to see if an open trade should be closed
   bool CloseNeeded = false;
   
   //Long 
   if (type == OP_BUY)
   {
      if (High[1] <= FibLowerConfirm && Low[1] <= FibLowerConfirm)
      {
         //Check the exit signal candle was a down candle
         if (Close[1] < Open[1] )
         {
            CloseNeeded = true;
         }//if (Close[1] < open[1]
         
      }//if (High[1] < FibLowerConfirm && Low[1] < FibLowerConfirm)
      
   }//if (type == OP_BUY)
   
   //Short
   if (type == OP_SELL)
   {
      if (High[1] >= FibUpperConfirm && Low[1] >= FibUpperConfirm)
      {
         //Check the exit signal candle was a rising candle
         if (Open[1] < Close[1] )
         {
            CloseNeeded = true;
         }//if (Close[1] < open[1]
                  
      }//if (High[1] < FibLowerConfirm && Low[1] < FibLowerConfirm)
      
   }//if (type == OP_SELL)
   
   
   return(CloseNeeded);
   
}//End bool CheckForExitSignal(int type)


bool DoesTradeExist(double PriceHigh, double PriceLow)
{

   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {
         if (OrderOpenPrice() < PriceHigh && OrderOpenPrice() > PriceLow) return(true);
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      

   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   return(false);
   
}//bool DoesTradeExist(double PriceHigh, double PriceLow)

void TradeEarlierEntryStrategy()
{
      
      if (TradeRfking2NightMode)
            {
               static int WuckingFait;
                  WuckingFait = 0;
                  if (Ask < FibUpperRetrace && Bid > FibLowerRetrace) WuckingFait = 1;
      }//if (TradeRfking2NightMode)
      
      
      static int AlertCount;
      bool SendTrade;
      
      double lot = Lot;
      if (UseScaleIn) lot/= ScaleIncrement;

   if (Trend == up && LatestSwing == low)
   {
      RefreshRates();
      double stop = NormalizeDouble(FibLow - (StopLossPips * Point), Digits);
      if (!UseAdaptableStopLoss) stop = NormalizeDouble(Ask - (StopLoss * Point), Digits);
      if (UseScaleIn)
      {
         
         if (StopLossPrice != 0) stop = StopLossPrice;
      }//if (UseScaleIn
      
      //Cycle through the trade levels to look for trading opportunities
      //Set them up.
      FibLevel[0] = FibPivot;
      FibLevel[1] = FibUpperRetrace;
      FibLevel[2] = FibUpperConfirm;
      FibLevel[3] = FibHigh;
      FibLevel[4] = 1000000;
      

      for (int cc = 0; cc <= 4; cc++)
      {
         int d = cc + 1;
         if (Ask > FibLevel[cc] && Ask < FibLevel[d] )
         {
            bool TradeExists = DoesTradeExist(FibLevel[cc], FibLevel[d] );
            if (!TradeExists) SendTrade = true;
            if (Ask > FibUpperConfirm) UseScaleOut = false;
            break;
         }//if (Bid < FibLevel[cc] && Bid > FibLevel[d] )
         
      }//for (int cc = 0; cc <= 4; cc++)
      
      if (TradeRfking2NightMode)
       {
            if (WuckingFait == 1 && SendTrade && !ShowAlertNotSendTrade) SendSingleTrade(OP_BUY, TradeComment, lot, Ask, NormalizeDouble(Ask - StopLoss * Point, Digits), 0);
            //if (WuckingFait == 1 && SendTrade && !ShowAlertNotSendTrade) Alert(Symbol(), "Early Buy");
            if (WuckingFait == 1 && SendTrade && !ShowAlertNotSendTrade) WuckingFait = 0;
      }//if (TradeRfking2NightMode)
      
      if (!TradeRfking2NightMode)
      {
      if (SendTrade)
      {
         if (OpenLotSize < Lot && SendTrade && !ShowAlertNotSendTrade) SendSingleTrade(OP_BUY, TradeComment, lot, Ask, stop, 0);

         if (ShowAlertNotSendTrade && AlertCount == 0)
         {
            Alert(Symbol(), " Buy trade setup");
            AlertCount++;
         }//if (ShowAlertNotSendTrade && AlertCount == 0)
         
      }//if (SendTrade)
      }//if (TradeRfking2NightMode==false)
   }//if (Trend == up)


   
   if (Trend == down && LatestSwing == high)
   {
      RefreshRates();
      //Check that market has moved far enough below the lowest of the scaled trades
      //to make a new trade worthwhile
      stop = NormalizeDouble(FibHigh + (StopLossPips * Point), Digits);
      if (!UseAdaptableStopLoss) stop = NormalizeDouble(Bid + (StopLoss * Point), Digits);
      if (UseScaleIn && StopLossPrice != 0) stop = StopLossPrice;
      
      //Cycle through the trade levels to look for trading opportunities
      //Set them up.
      FibLevel[0] = FibPivot;
      FibLevel[1] = FibLowerRetrace;
      FibLevel[2] = FibLowerConfirm;
      FibLevel[3] = FibLow;
      FibLevel[4] = 0;
      
      for (cc = 0; cc <= 4; cc++)
      {
         d = cc + 1;
         if (Bid < FibLevel[cc] && Bid > FibLevel[d] )
         {
            TradeExists = DoesTradeExist(FibLevel[cc], FibLevel[d] );
            if (!TradeExists) SendTrade = true;
            if (Bid < FibLowerConfirm) UseScaleOut = false;
            break;
         }//if (Bid < FibLevel[cc] && Bid > FibLevel[d] )
         
      }//for (int cc = 0; cc <= 4; cc++)

      if (TradeRfking2NightMode)
      {
         if (WuckingFait == 1 && SendTrade && !ShowAlertNotSendTrade) SendSingleTrade(OP_SELL, TradeComment, lot, Ask, NormalizeDouble(Bid + StopLoss * Point, Digits), 0);
         //if (WuckingFait == 1 && SendTrade && !ShowAlertNotSendTrade) Alert(Symbol(), "Early Sell");
         if (WuckingFait == 1 && SendTrade && !ShowAlertNotSendTrade) WuckingFait = 0;
      }//if (TradeRfking2NightMode)


      if (!TradeRfking2NightMode)
      {
      if (SendTrade)
      {
         if (OpenLotSize < Lot && !ShowAlertNotSendTrade) SendSingleTrade(OP_SELL, TradeComment, lot, Bid, stop, 0);

         if (ShowAlertNotSendTrade && AlertCount == 0)
         {
            Alert(Symbol(), " Sell trade setup");
            AlertCount++;
         }//if (ShowAlertNotSendTrade && AlertCount == 0)
         
      }//if (SendTrade)
      }//if (TradeRfking2NightMode==false)
   }//if (Trend == down)
      

}//End void TradeEarlierEntryStrategy()


void TradeOriginalStrategy()
{
   //Sends trades as specified in the trading pdf
   
   
   static int AlertCount;
   if (Ask < FibUpperRetrace && Bid > FibLowerRetrace) AlertCount = 0;
   
   double lot = Lot;
   if (UseScaleIn) lot/= ScaleIncrement;
   
   if (High[1] > FibUpperConfirm && Low[1] > FibUpperConfirm)
   {
      //Check that market has moved far enough above the highest of the scaled trades
      //to make a new trade worthwhile
      if (UseScaleIn)
      {
         double pd = Ask - HighestBuyTrade;
         if (pd < MinPipsToNextTrade * Point) return;
      }//if (UseScaleIn)
      
      
      if (Trend == up)
      {
         RefreshRates();
         double stop = NormalizeDouble(FibLow - (StopLossPips * Point), Digits);
         if (!UseAdaptableStopLoss) stop = NormalizeDouble(Ask - (StopLoss * Point), Digits);
         if (UseScaleIn)
         {
            
            if (StopLossPrice != 0) stop = StopLossPrice;
         }//if (UseScaleIn
         
         //Check the trading candle is the first in the confirmation area to avoide entering the market too
         //deeply into a move that is likely to retrace
         if (Low[2] < FibUpperConfirm)
         {
            if (OpenLotSize < Lot && !ShowAlertNotSendTrade) SendSingleTrade(OP_BUY, TradeComment, lot, Ask, stop, 0);
            //if (TradeRfking2NightMode)Alert(Symbol(), "Classic Buy");
            if (ShowAlertNotSendTrade && AlertCount == 0)
            {
               Alert(Symbol(), " Buy trade setup");
               AlertCount++;
            }//if (ShowAlertNotSendTrade && AlertCount == 0)
            
         }//if (Low[2] < FibUpperConfirm)
      }//if (Trend == up)
    }//if (Open[1] > FibUpperConfirm && Close[1] > FibUpperConfirm)
   

   if (High[1] < FibLowerConfirm && Low[1] < FibLowerConfirm)
   {
      
      if (Trend == down)
      {
         RefreshRates();
         //Check that market has moved far enough below the lowest of the scaled trades
         //to make a new trade worthwhile
         if (UseScaleIn)
         {
            pd = LowestSellTrade - Bid;
            if (pd < MinPipsToNextTrade * Point) return;
         }//if (UseScaleIn)
         stop = NormalizeDouble(FibHigh + (StopLossPips * Point), Digits);
         if (!UseAdaptableStopLoss) stop = NormalizeDouble(Bid + (StopLoss * Point), Digits);
         if (UseScaleIn && StopLossPrice != 0) stop = StopLossPrice;
         //Check the trading candle is the first in the confirmation area to avoide entering the market too
         //deeply into a move that is likely to retrace
         if (High[2] > FibLowerConfirm)
         {
            if (OpenLotSize < Lot && !ShowAlertNotSendTrade) SendSingleTrade(OP_SELL, TradeComment, lot, Bid, stop, 0);
            //if (TradeRfking2NightMode)Alert(Symbol(), "Classic Sell");
            if (ShowAlertNotSendTrade && AlertCount == 0)
            {
               Alert(Symbol(), " Sell trade setup");
               AlertCount++;
            }//if (ShowAlertNotSendTrade && AlertCount == 0)
            
         }//if (High[2] > FibUpperConfirm)
      }//if (Trend == down)
      
   }//if (Open[1] < FibLowerConfirm && Close[1] < FibLowerConfirm)


}//End void TradeOriginalStrategy()


void ScaleOut()
{
//FibSize = FibHigh - FibLow;
   //FibUpperConfirm = NormalizeDouble(FibLow + (FibSize * 75 / 100), Digits);
   
   //Set up target prices
   double BuyTargetPrice[4], BuyCloseLots[4];
   double SellTargetPrice[4], SellCloseLots[4];
   
   //Buy targets
   BuyTargetPrice[1] = NormalizeDouble(FibLow + (FibSize * BuyScaleOutLevel1 / 100), Digits);
   BuyCloseLots[1] = BuyScaleOutLot1;
   BuyTargetPrice[2] = NormalizeDouble(FibLow + (FibSize * BuyScaleOutLevel2 / 100), Digits);
   BuyCloseLots[2] = BuyScaleOutLot2;
   BuyTargetPrice[3] = NormalizeDouble(FibLow + (FibSize * BuyScaleOutLevel3 / 100), Digits);
   BuyCloseLots[3] = BuyScaleOutLot3;
   
   
   //Sell targets
   SellTargetPrice[1] = NormalizeDouble(FibLow + (FibSize * SellScaleOutLevel1 / 100), Digits);
   SellCloseLots[1] = SellScaleOutLot1;
   SellTargetPrice[2] = NormalizeDouble(FibLow + (FibSize * SellScaleOutLevel2 / 100), Digits);
   SellCloseLots[2] = SellScaleOutLot2;
   SellTargetPrice[3] = NormalizeDouble(FibLow + (FibSize * SellScaleOutLevel3 / 100), Digits);
   SellCloseLots[3] = SellScaleOutLot3;
   
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      //Find open trades unique to this chart
      if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      
      {         
         if (OrderType() == OP_BUY)
         {
            bool result = true;
            for (int d = 1; d <= 3; d++)
            {
               if (Ask >= BuyTargetPrice[d] && OrderLots() > Lot - BuyCloseLots[d] 
                   && OrderProfit() > 0 && Close[1] < BuyTargetPrice[d] )
               {
                  RefreshRates();
                  result = OrderClose(OrderTicket(), BuyCloseLots[d], Ask, 500, CLR_NONE);
                  return;
               }//if (Ask > BuyScaleOutLevel1 && OrderLots() > Lot - BuyScaleOutLot1)
            }//for (int d = 1; d <= 3; d++)
            
            if (!result)
            {
               int err=GetLastError();
               Alert(Symbol(), " part-close failed with error(",err,"): ",ErrorDescription(err));               
            }//if (!result)
         }//if (OrderType() == OP_BUY)
         
         if (OrderType() == OP_SELL)
         {
            result = true;
            for (d = 1; d <= 3; d++)
            {            
               if (Bid < SellTargetPrice[d] && OrderLots() > Lot - SellCloseLots[d] 
                   && OrderProfit() > 0  && Close[1] > SellTargetPrice[d] )
               {
                  RefreshRates();
                  result = OrderClose(OrderTicket(), SellCloseLots[d], Bid, 500, CLR_NONE);
                  return;
               }//if (Bid < SellScaleOutLevel1 && OrderLots() > Lot - SellScaleOutLot1)
            }//for (d = 1; d <= 3; d++)
            
            if (!result)
            {
               err=GetLastError();
               Alert(Symbol(), " part-close failed with error(",err,"): ",ErrorDescription(err));               
            }//if (!result)
         }//if (OrderType() == OP_SELL)
         
      }//if (OrderMagicNumber()==MagicNumber && OrderSymbol() == Symbol() )      

   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)


}//End void ScaleOut()

void DrawFib(string Name, color col)
{
         
      ObjectCreate(Name,OBJ_FIBO,0,SwingStartTime,SwingLow,SwingEndTime,SwingHigh);
      ObjectSet(Name, OBJPROP_STYLE, STYLE_DASH);
      ObjectSet(Name, OBJPROP_COLOR, col);
      ObjectSet(Name, OBJPROP_LEVELCOLOR, col);
      ObjectSet(Name, OBJPROP_WIDTH, 1);
      ObjectSet(Name, OBJPROP_FIBOLEVELS, 7);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+0, 0);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+1, 0.25);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+2, 0.382);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+3, 0.5);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+4, 0.618);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+5, 0.75);
      ObjectSet(Name, OBJPROP_FIRSTLEVEL+6, 1);
      
      string tf = "Mtf ";
      if (col == HtfFibColour) tf = "Htf ";
      if (col == FibColour) tf = "";
      
      ObjectSetFiboDescription(Name, 0, tf + "High (100)"+ "  %$");
      ObjectSetFiboDescription(Name, 1, tf + "Upper confirm (75)"+ "  %$");
      ObjectSetFiboDescription(Name, 2, tf + "Upper retrace level (61.8)"+ "  %$");
      ObjectSetFiboDescription(Name, 3, tf + "Pivot (50)"+ "  %$");
      ObjectSetFiboDescription(Name, 4, tf + "Lower retrace level 38.2)"+ "  %$");
      ObjectSetFiboDescription(Name, 5, tf + "Lower confirm 25)"+ "  %$");
      ObjectSetFiboDescription(Name, 6, tf + "Low 0)"+ "  %$");


}//void DrawFib(string Name, color col)



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   bool TradeAllowed = true;//Any failed condition will set this to false and stop a trade being sent
   static int AlertCount;
   if (Ask < FibUpperRetrace && Bid > FibLowerRetrace) AlertCount = 0;
   
   if (UseScaleOut && OrdersTotal() > 0) ScaleOut();
   
   //Deal with failed trade closures first
   static bool TradesCloseFailed = false;
   if (TradesCloseFailed)
   {
      TradesCloseFailed = CloseAllTrades();
      if (TradesCloseFailed) return;//Have to keep trying
   }//if (TradesCloseFailed)
   
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )

      
   //A fib is only valid if the price has retraced inside the decision zone. The global variable GvName
   //holds the value 0 when the fib is re-drawn. Set it to 1 if the fib becomes valid.
   if (Ask < FibUpperRetrace && Bid > FibLowerRetrace) GlobalVariableSet(GvName, 1);
   
   //Read the value of the gv and set FibIsValid accordingly
   int v = GlobalVariableGet(GvName);
   if (v == 1) FibIsValid = true;
   else FibIsValid = false;
   
   //Redraw the fib if the market has moved above\below HiLo and there are no trades open - fib has not been validated yet
   if (OldBars != Bars)
   {
      OldBars = Bars;

      //Read Rsi
      //RsiDirection = unchanged;
      double PrevRsiVal = RsiVal;
      RsiVal = iRSI(NULL, RsiTimeFrame, RsiPeriod, PRICE_CLOSE, 0);
      //if (RsiVal > PrevRsiVal) RsiDirection = up;
      //if (RsiVal < PrevRsiVal) RsiDirection = down;      
      
      //PreviousRsiVal = iRSI(NULL, RsiTimeFrame, RsiPeriod, PRICE_CLOSE, 1);
      
            
      Trend = undecided;
      if (RsiVal >= 55) Trend = up;
      if (RsiVal <= 45) Trend = down;
      /*
      //Check validity of trend reading      
      if (Trend == up)
      {
         if (RsiDirection == down) 
         {
            Trend = upbutuntradable;
            TradeAllowed = false;
         }//if (RsiDirection == down || H4RsiDirection == down || H1RsiDirection == down) 
         
      }//if (Trend == up)
      
      if (Trend == down)
      {
         if (RsiDirection == up) 
         {
            Trend = downbutuntradable;
            TradeAllowed = false;
         }//if (RsiDirection == up || H4RsiDirection == up || H1RsiDirection == up) 
         
      }//if (Trend == down)
      */
         
      //Manual trend setting
      if(OverrideRobot)
      {
         if (MarketTrendIsLong) Trend = up;
         if (MarketTrendIsShort) Trend = down;
         if (MarketIsRanging) Trend = ranging;
      }//if(OverrideRobot)
      
      
      //Fib adjustments
      //Draw fibs from smallest to largest to ensure that each larger swing has extremes that encompass the smaller ones
      bool AdjustFib = true;
      SwingHigh = 0;
      SwingLow = 1000000;
   
      //Trading fib
      AdjustFib = true;
      if (!RobotAdjustsFib) AdjustFib = false;
      if (!RobotAdjustsFibAfterTradeOpens) AdjustFib = false;
      
      if (AdjustFib)
      {
         GetSwing(Period() );
         GetFibLevels(FiboName);
         //FiboName=TimeToStr(a.high.time,TIME_DATE|TIME_MINUTES);
         DrawFib(FiboName, FibColour);
         //Make sure the robot has not missed a fib validation

         //Swing high
         if (SwingStartTime < SwingEndTime && Ask < FibUpperRetrace)
         {
            GlobalVariableSet(GvName, 1);
         }
         
         //Swing low
         if (SwingStartTime > SwingEndTime && Bid > FibLowerRetrace)
         {
            GlobalVariableSet(GvName, 1);
         }
      }//if (AdjustFib)
      
      //Medium tf
      AdjustFib = true;
      if (!RobotDrawsMtfFib) AdjustFib = false;
      if (!RobotAdjustsMtfFib) AdjustFib = false;
      if (!RobotAdjustsMtfFibAfterTrade) AdjustFib = false;
      if (AdjustFib)
      {
         GetSwing(MediumTimeFrame );
         GetFibLevels(MtfFiboName);
         //FiboName=TimeToStr(a.high.time,TIME_DATE|TIME_MINUTES);
         DrawFib(MtfFiboName, MtfFibColour);
         //Make sure the robot has not missed a fib validation
      }//if (AdjustFib)
      
      
      //Higher tf
      AdjustFib = true;
      if (!RobotDrawsHtfFib) AdjustFib = false;
      if (!RobotAdjustsHtfFib) AdjustFib = false;
      if (!RobotAdjustsHtfFibAfterTrade) AdjustFib = false;
      if (AdjustFib)
      {
         GetSwing(HigherTimeFrame );
         GetFibLevels(HtfFiboName);
         //FiboName=TimeToStr(a.high.time,TIME_DATE|TIME_MINUTES);
         DrawFib(HtfFiboName, HtfFibColour);
         //Make sure the robot has not missed a fib validation
      }//if (AdjustFib)
      
      //Re-Read swing and fib values
      SwingHigh = 0;
      SwingLow = 1000000;
      GetSwing(Period() );
      GetFibLevels(FiboName);
      if (RobotDrawsFib) DrawFib(FiboName, FibColour);

      //Look for existing trades.
      //This function also takes care of closing trades when upper/lower confirm has been broken.
      //Also moves stop loss to 10 pips above/below hi/low - needed when trades are profitable and the swing has
      //left the stop behind.
      GetPositionInformation();
      
      
      if (GlobalTotalTradesOpen >= GlobalMaximumTradesAllowed)
      {
         TradeAllowed = false;
      }
      
      //Abort rest of code if I want trading stopped
      if (StopTrading)
      {
         TradeAllowed = false;
      }//if (StopTrading)

      
      //Sunday candle
      if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal()) == 0) 
      {
         TradeAllowed = false;
      }//if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal()) == 0) 
   
      //Trading hours
      TradeHour = false;
      int lhour = TimeHour(TimeLocal() );
      if ((lhour>=start_hourm && lhour<end_hourm) || (lhour>=start_houre && lhour<end_houre)) TradeHour = true;
      if (!TradeHour)
      {
         TradeAllowed = false;
      }//if (!TradeHour)

      

      //Look for new trades. Market must be in 'the box'
      if (IsTradeAllowed() )
      {   
         bool SendTrade = false;
         
         if (FibIsValid && TradeAllowed)
         {

            
            
           // rfking2 came up with an alternative method of trading, so this is commented out for now
            //Select trading strategy
            
            
          
            if (TradeOriginalStrategy && TradeAllowed)
            {
               TradeOriginalStrategy();
            }//if (TradeOriginalStrategy)
            
            if (TradeEarlyEntries && TradeAllowed)
            {
               TradeEarlierEntryStrategy();
            }//if (TradeEarlyEntries)
            
            //rfkin2's trading strategy.
            //This is breathtakingly imaginative and we are all deeply grateful to you for this
            if (TradeRfking2NightMode && TradeAllowed)
            {
               if (OpenTradesTotal < 1) TradeOriginalStrategy();
               if (OpenTradesTotal >0) TradeEarlierEntryStrategy();
            }//if (TradeRfking2NightMode)
            
            
            
         }//if (FibIsValid && TradeAllowed)
      }//if (IsTradeAllowed() )
   }//if (OldBars != Bars)
   
   DisplayUserFeedback();
   
//----
   return(0);
}
//+------------------------------------------------------------------+7